﻿using System;
namespace State.Ejm1
{
    /// <summary>
    /// Funcionalidad basica de una cuenta. Con ella el objeto cliente puede hacer operaciones de depósitos y 
    /// retiros.
    /// </summary>
    public class BusinessAccount
    {
        //Contantes para definer los limites de las transacciones
        public const double MinBalance = 2000.00;
        public const double OvedrawLimit = -1000.00;
        public const double TransFeeNormal = 2.00;
        public const double TransFeeOverdraw = 5.00;
        public const String ErrOverdrawLimitExceed = "Error: Transaction cannot be processed. "
                + "Overdraw limit exceeded.";
        //Atributos
        private State ObjState;
        private String AccountNumber;
        private double Balance;

        public BusinessAccount(String accountNum)
        {
            AccountNumber = accountNum;
            ObjState = State.InitialState(this);
        }

        public void SetState(State newState)
        {
            ObjState = newState;
        }

        public State GetState()
        {
            return ObjState;
        }

        public String GetAccountNumber()
        {
            return AccountNumber;
        }

        public bool Deposit(double amount)
        {
            return GetState().Deposit(amount);
        }

        /**
         * Retiro
         * @param amount
         * @return
         */
        public bool Withdraw(double amount)
        {
            return GetState().Withdraw(amount);
        }

        public double GetBalance()
        {
            return Balance;
        }

        public void SetBalance(double newBalance)
        {
            Balance = newBalance;
        }
    }
}
