﻿using System;
namespace State.Ejm1
{
    /// <summary>
    /// Estado de la cuenta: sin arancel, sin gratificacion.
    /// El balance de la cuenta es menor que el balance minimo
    /// </summary>
    public class NoTransactionFeeState : State
    {
        public NoTransactionFeeState(BusinessAccount account)
            : base(account)
        {

        }

        public NoTransactionFeeState(State source)
            : base(source)
        {

        }

        public override bool Deposit(double amount)
        {
            return base.Deposit(amount);
        }

        public override bool Withdraw(double amount)
        {
            double balance = GetContext().GetBalance();
            if ((balance - amount) > BusinessAccount.OvedrawLimit)
            {
                base.Withdraw(amount);
                return true;
            }
            else
            {
                Console.WriteLine(BusinessAccount.ErrOverdrawLimitExceed);
                return false;
            }
        }

        public override State TransitionState()
        {
            double balance = GetContext().GetBalance();
            if (balance < 0)
            {
                GetContext().SetState(new OverDrawnState(this));
            }
            else
            {
                if (balance < BusinessAccount.MinBalance)
                {
                    GetContext().SetState(new TransactionFeeState(this));
                }
            }
            return GetContext().GetState();
        }
    }
}
