﻿using System;
namespace State.Ejm1
{
    /// <summary>
    /// Define el comportamiento común de todas las cuentas. Es una clase base concreta.
    /// </summary>
    public class State
    {
        private BusinessAccount Context;

        public State(BusinessAccount account)
        {
            SetContext(account);
        }

        public BusinessAccount GetContext()
        {
            return Context;
        }

        public void SetContext(BusinessAccount newAccount)
        {
            Context = newAccount;
        }

        public virtual State TransitionState()
        {
            return null;
        }

        public State(State source)
        {
            SetContext(source.GetContext());
        }

        public static State InitialState(BusinessAccount account)
        {
            return new NoTransactionFeeState(account);
        }
        //deposito
        public virtual bool Deposit(double amount)
        {
            double balance = GetContext().GetBalance();
            GetContext().SetBalance(balance + amount);
            TransitionState();
            Console.WriteLine("An amount " + amount + " is deposited ");
            return true;
        }
        //Retiro
        public virtual bool Withdraw(double amount)
        {
            double balance = GetContext().GetBalance();
            GetContext().SetBalance(balance - amount);
            TransitionState();
            Console.WriteLine("An amount " + amount + " is withdrawn ");
            return true;
        }
    }
}
